// Package api provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.8.2 DO NOT EDIT.
package api

import (
	"time"

	openapi_types "github.com/deepmap/oapi-codegen/pkg/types"
)

// ConsentPage defines model for ConsentPage.
type ConsentPage struct {
	Url string `json:"url"`
}

// Error defines model for Error.
type Error struct {
	Code    int    `json:"code"`
	Message string `json:"message"`
}

// User defines model for User.
type User struct {
	Admin     bool                `json:"admin"`
	CreatedAt time.Time           `json:"created_at"`
	Email     openapi_types.Email `json:"email"`

	// GradeLevel is only present if teacher is false.
	GradeLevel *int   `json:"grade_level,omitempty"`
	Id         string `json:"id"`
	Name       string `json:"name"`
	Picture    string `json:"picture"`
	Teacher    bool   `json:"teacher"`
}

// DefaultResponse defines model for DefaultResponse.
type DefaultResponse Error

// AuthorizeCallbackParams defines parameters for AuthorizeCallback.
type AuthorizeCallbackParams struct {
	State string `json:"state"`
	Code  string `json:"code"`
}

// GenOauthParams defines parameters for GenOauth.
type GenOauthParams struct {
	Callback string `json:"callback"`
}

// DeleteTokenParams defines parameters for DeleteToken.
type DeleteTokenParams struct {
	All *bool `json:"all,omitempty"`

	// User authentication token.
	Token string `json:"token"`
}

// GetAllUsersParams defines parameters for GetAllUsers.
type GetAllUsersParams struct {
	// User authentication token.
	Token string `json:"token"`
}

// GetUserByEmailParams defines parameters for GetUserByEmail.
type GetUserByEmailParams struct {
	// User email.
	Email openapi_types.Email `json:"email"`

	// User authentication token.
	Token string `json:"token"`
}

// ModifyOtherUserJSONBody defines parameters for ModifyOtherUser.
type ModifyOtherUserJSONBody struct {
	Admin      bool                 `json:"admin"`
	GradeLevel int                  `json:"grade_level"`
	Name       string               `json:"name"`
	NewEmail   *openapi_types.Email `json:"new_email,omitempty"`
	Picture    string               `json:"picture"`
	Teacher    bool                 `json:"teacher"`
}

// ModifyOtherUserParams defines parameters for ModifyOtherUser.
type ModifyOtherUserParams struct {
	// User email.
	Email openapi_types.Email `json:"email"`

	// User authentication token.
	Token string `json:"token"`
}

// GetMeParams defines parameters for GetMe.
type GetMeParams struct {
	// User authentication token.
	Token string `json:"token"`
}

// ModifyUserJSONBody defines parameters for ModifyUser.
type ModifyUserJSONBody struct {
	GradeLevel int    `json:"grade_level"`
	Name       string `json:"name"`
}

// ModifyUserParams defines parameters for ModifyUser.
type ModifyUserParams struct {
	// User authentication token.
	Token string `json:"token"`
}

// ModifyOtherUserJSONRequestBody defines body for ModifyOtherUser for application/json ContentType.
type ModifyOtherUserJSONRequestBody ModifyOtherUserJSONBody

// ModifyUserJSONRequestBody defines body for ModifyUser for application/json ContentType.
type ModifyUserJSONRequestBody ModifyUserJSONBody
